/* Programming activity: Static instance variables and methods
 *
 * The following data type represents a Dog with a fixed image and sound effect.
 * 
 * Part 1, add the missing code in the main() method to create an ArrayList of
 * the number of Dog objects specified as the first command line argument.
 * After completing this, run the program for different values of N observing
 * how much memory is taken up by the collection of Dog objects.
 * 
 * Part 2, fix the instance variables such that memory isn't wasted repeating
 * the constant values for the dog image and sound effect files. Run the program
 * and observe the change in the amount of heap memory used.
 * 
 * Part 3, you want to keep track of the total number of Dog objects created
 * by the system. Add a getCount() method to return this number. This will require
 * an additional instance variable as well as additional code in the Dog 
 * constructor.
 *  
 */

import java.util.ArrayList;

public class Dog
{
   private double x = 0.0;
   private double y = 0.0;
   private static final String IMAGE = "dog.jpg";   // TODO 2: fix instance variable declaration to save memory
   private static final String AUDIO = "dog.wav";   // TODO 2: fix instance variable declaration to save memory
   private static int count = 0;
   
   public Dog(double x, double y)
   {
      this.x = x;
      this.y = y;
      count++;
   }
   
   public void show()
   {	  
      StdDraw.picture(x, y, IMAGE);
      StdAudio.play(AUDIO);
   }
       
   public static int getCount()
   {
       return count;
   }
   
   public static void main(String [] args)
   {
       // Program takes a single integer command line argument specifying how many Dog objects to create
       final int N = Integer.parseInt(args[0]);
       
       Stats stats = new Stats();
       long startBytes = (long) (1024 * 1024 * stats.heapMemory());
       System.out.printf("Start, bytes of heap memory = %d\n", startBytes);

       // TODO 1: Declare and instantiate an ArrayList that can hold Dog objects
       ArrayList<Dog> dogs = new ArrayList<Dog>();
       
       for (int i = 0; i < N; i++)
       {
           // TODO 1: add the Dog object to the ArrayList, you can add at any (x, y) you like
           dogs.add(new Dog(0.5, 0.5));
       }
       
       // TODO 3: add method getCount(), you'll need to add an instance variable, and add code to the constructor 
       System.out.printf("Number of Dog objects on heap = %d\n", Dog.getCount());
      
       long endBytes = (long) (1024 * 1024 * stats.heapMemory());
       System.out.printf("End, bytes of heap memory = %d\n", endBytes);
                 
       // Calculate the estimated memory required by Dog
       System.out.printf("Estimate, bytes per Dog = %.2f\n", (endBytes - startBytes) / (double) N);
   }
}
